#!/usr/bin/perl -w
my $hotknotsbin = '/home/user/HotKnots_v2.0/bin' ; 
#
# the line indicated above is the full path of the bin directory of
# the installed HotKnots. The directory `HotKnots_v2.0' was automatically
# created when instaling HotKnots.
#
#
#  myhotsknots.pl : a perl script for executing HotKnots 
#

   # linux
   $exe = '../bin/HotKnots ' ;
   $rm = 'rm -rf ';
   $PWD = 'pwd' ;

# temporary directory/file names
if($ARGV[0] =~ /^-/) {
   print "ERROR: input file name error. file name = $ARGV[0]\n" ;
   exit(0);
}
unless (open(IN,$ARGV[0])) {
   print "ERROR: input file cannot be opened.\n" ;
   exit(0);
} 

my $inp = '' ;
my $title = $ARGV[0] ;
while(<IN>) {
   chomp;
   if (/^>/) {
      $title = $_ ;
      $title =~ s/^>\s*// ;
      $inp = ''

   } else {
      # convert a letter othr than ACGUT to N !!
      $_ =~ tr/a-z/A-Z/ ; # to capital
      $_ =~ s/[^ACGTU]/N/g ;
      $inp .= $_ ;
   }
}


$tempdir1 = $ARGV[0] ;
$tempdir1 =~ s/^.*\/// ;
$tempdir1 = $tempdir1.".wrkdir.".time ;

$root = `$PWD` ;
$root =~ s/\n$// ;

mkdir($tempdir1) ;
chdir($tempdir1) ;

system("cp -r $hotknotsbin .");

mkdir($tempdir1) ;
chdir($tempdir1) ;

mkdir('output') ;

my $x = $ARGV[0] ;
$x =~ s/\.seq//;
$options = "  -s $inp -noPS -b  ".join(' ', @ARGV[1..$#ARGV]) ;

&run_exe ($options) ; 

foreach (@output) {
   chomp ;
   if (/^Seq:/) {
      $_ =~ s/^Seq:\s+// ;
      #print $title ;
      print "$_\n" ;
   } elsif (/^S0:\s+/) {
      my @a = split ;
      $a[1] =~ s/^S0:\s+// ;
      print "$a[1] $a[2]\n" ;
   }
}


&postprocess() ;


sub postprocess() {
   chdir($root) ;
   system("$rm $tempdir1");
}


sub run_exe {
# Input: $opt, $inp(local), $tempfile1, $pmat_name, $fname
# Output: @output (local), stdout
   my ($opt) = @_ ;

   @output = `$exe $opt` ;
}
